/* 			   ShokDial					   */
/* This is (I have never seen one anyway, I apologize if I'm wrong)  	   */
/* the first war dialer that I've ever seen for unix. This will            */
/* compile on most/all unixs' (I didn't use any spiffy or complex	   */
/* functions).	 							   */
/*  		    	    Enjoy,                                         */
/*		     --==+*~(Shok)~*+==--			           */

#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <ctype.h>
#include <signal.h>

#define ERROR -1
#define LOGFILE "wardial.log" /* Used as default for logging    */
                              /* unless you change this define  */
                              /* or specify it as an option     */

#define TIMEOUT 25 /* YOU WANT TO CONFIGURE THIS!!! 		*/
                   /* This is how long it will wait until it    */
                   /* gives up. 				*/

/* 			Global variables			   */
/* 			----------------			   */
int fd; 	     /* fd for modem 				   */
int numbytes;        /* To verify that all the bytes were written  */
int random;	     /* Use random scanning if this is set         */
char *ProgName;	     /* Um duh.					   */
char LocalOrLong[2]; /* Dialing long distance of local 		   */
int First3Digits;    /* Such as "555" of 555-XXXX 	           */
                     /* However this also serves as the area code  */
                     /* for a long distance number                 */
int Last3Digits;     /* Used as XXX-555-XXXX                       */
int ScanMin;         /* Number to scan from....like 0000 and up    */
int ScanMax;         /* Stop scanning when this number is reached  */
char *LogFile;       /* Where to log connections 		   */
char buf[512]; 	     /* Buffer for strings returned by modem       */
FILE *logfile;       /* for the log file 	  		   */
char modemport[15];  /* Hold the modem port                        */
char hangupport[15]; /* Hold the hangup port                       */
/* FILE *resume; */  /* To resume scanning where left off          */

struct termios options; /* Baud rate, modes, etc.                  */


/* 			Function prototypes		 	        */ 
/* 			------------------- 			        */
void usage(void);	      /*  Help/usage			        */
void version(void);           /*  Display version                       */
void intro(void);             /*  An introduction			*/
void get_num(void);	      /*  Get phone number and scan prefix      */
void get_scannum(void);       /*  Get range to scan                     */
void open_port(void);         /*  Open modem port for dialing	        */
void set_options(void);       /*  Set baud rate, termios, etc.          */
void init_modem(void);        /*  Initialize the modem		   	*/
void dial_number(void);	      /*  Dial the number			*/
void hangup(void);            /*  Hang up modem.                       	*/
void sighandler(int signum);  /*  Used when signals are received	*/

/* Check read/write/opens for errors */
void check_for_error(int fd, int num, char *s);

/* Check if the phone num was valid */ 
void local_validnum(int digits);
void long_validnum(int firstdigits, int lastdigits);


void main(int argc, char **argv)
{
  struct sigaction sig, sigdef;

  system("clear");

  /* ------------------------------------------------- */

  ProgName = argv[0];

  if (argc == 2) {
        if ((strcasecmp(argv[1], "-r")) == 0) random = 1;
        else if ((strcasecmp(argv[1], "-h")) == 0) usage();
        else if ((strcasecmp(argv[1], "-help")) == 0) usage();
        else if ((strcasecmp(argv[1], "--help")) == 0) usage();
        else if ((strcasecmp(argv[1], "-v")) == 0) version();
        else if ((strcasecmp(argv[1], "--version")) == 0) version();
        else LogFile=argv[1];
  }

  else if (argc == 3) {
	if ((strcasecmp(argv[1], "-r")) == 0) {
        	random = 1;
        	LogFile=argv[2];
        }
        else usage();
  }

  else if (argc > 3) usage(); 

  else {
        fprintf(stderr, "No log file specified....using %s as log file.\n", LOGFILE);
        fprintf(stderr, "-r (random scanning) option not given, using sequential scanning instead.\n");
        LogFile=LOGFILE;
  }

/* -------------------------------------------------- */
  modemport="/dev/";
  hangupport="/dev/";
  strcat(modemport, MODEMPORT);
  strcat(hangupport, HANGUPPORT);
/* -------------------------------------------------- */

/* -------------------------------------------------- */

  sleep(4);
  system("clear"); /* Clear the screen */


/* -------------------------------------------------- */

sig.sa_handler = sighandler;
sigdef.sa_handler = SIG_IGN;
sigemptyset (&sig.sa_mask);
sig.sa_flags = 0;

sigaction(SIGHUP, NULL, &sigdef);
sigaction(SIGINT, &sig, NULL);
sigaction(SIGTERM, &sig, NULL);

/* -------------------------------------------------- */

  logfile=fopen(LogFile, "a");
  /* resume=fopen(".resume", "w"); */

  intro();

if (random != 1) {
  get_num();     /* Get the phone number                                */
  get_scannum;   /* Get the range to scan 				*/
}
  open_port();   /* Open MODEMPORT (by default /dev/cua1) 		*/
  set_options;   /* Set baud rate, terminal modes, etc.                 */
  init_modem();  /* Send the modem ATZ etc..				*/

  dial_number(); /* Dial the number/do the scanning			*/ 
  hangup();      /* Disconnect					        */

  close(fd);
}

/* -------------------------------------------------- */

void version(void)
{
  fprintf(stderr, "This is ShokDial, v1.0...please keep notice of this.\n");
  fprintf(stderr, "in case this program under goes some new features etc.\n");
  fprintf(stderr, "\t\t--==+*~(Shok)~*+==--\n");
  exit(0);
}

/* -------------------------------------------------- */

void usage(void)
{
  	fprintf(stderr, "Usage: %s [options] [logfile]\n", ProgName);
        fprintf(stderr, "Options:\n");
        fprintf(stderr, "-r for random (as opposed to sequential) scanning\n");
        fprintf(stderr, "-h for help....what you're seeing now");
        fprintf(stderr, "-v for the version...because this will probably undergo changes\n\n");
  	fprintf(stderr, "If no log file is specified, \"%s\" is used.\n", LOGFILE);
	exit(0);
}

/* -------------------------------------------------- */

void intro(void)
{
  printf("Shok's war dialer for UNIX (affectionately known as ShokDial).....\n");
  printf("------------------------------------------------------------------\n");
  printf("This is still in the beta version so it doesn't have a nice\n");
  printf("graphical interface yet.\n");
  printf("\nWell what you do here, is enter 0000 for the range to begin\n");
  printf("scanning and 9999 to end scanning if you want to scan all the\n");
  printf("possible ranges, but you can put 4444 for the nmber to start\n");
  printf("and 5555 for the number to begin to scan XXX-[4444-5555] for\n"); 
  printf("local numbers and it would be 1-XXX-XXX-[4444-5555] for long\n");
  printf("distance.\n");
  printf("\nAlso, you can use random scanning (as opposed to sequential\n");
  printf("scanning) by specifying the \"-r\" option...type:\n");
  printf("%s -h for help.\n\n", ProgName);
  printf("Anyway..enjoy!\n");
  printf("\t\t\t--==+*~(Shok)~*+==--\n\n");
  
  printf("Hit any key to continue.\n");
  getchar();
}

/* -------------------------------------------------- */

void get_num(void)
{

  printf("Scanning..\n(L)ocal, Long (D)istance\n");
  scanf("%2s", &LocalOrLong);

  if((strncasecmp(LocalOrLong, "L", 1)) == 0) {
	  printf("Enter number to dial (753 for 753-XXXX): ");
    	  scanf("%d", &First3Digits);
	  local_validnum(First3Digits);

  } 
  else if ((strncasecmp(LocalOrLong, "D", 1)) == 0) {
	printf("Enter number to dial (555555 for 555-555-XXXX): ");
  	scanf("%3d%3d", &First3Digits, &Last3Digits);
	long_validnum(First3Digits, Last3Digits);

  } 
  else {
	fprintf(stderr, "You must specify L for local or D for Long Distance\n");
        exit(ERROR);
  }

}

/* -------------------------------------------------- */

void get_scannum(void)
{
  printf("Enter number to start scanning at: ");
  scanf("%4d", &ScanMin);
  putchar('\n');

  if ((ScanMin >= 0) && (ScanMin <= 9999)) { /* Do nothing */
  } 
  else {
	fprintf(stderr, "%d is invalid.\nScanning range must be 0000-9999\n", ScanMin);
	exit(ERROR);
  }

  printf("Enter number to end scanning: ");
  scanf("%4d", &ScanMax);
  putchar('\n');
  
  if ((ScanMax > ScanMin) && (ScanMax > 0) && (ScanMax <= 9999)) { 
  	/* Do nothing */
  } 
  else {
	fprintf(stderr, "%d is invalid.\nScanning range must be 0000-9999\n", ScanMax);
	exit(ERROR);
  }
  
}

/* -------------------------------------------------- */

void open_port(void)
{
  printf("Opening modem for dialing...\n");
  fd = open(modemport, O_RDWR | O_NOCTTY | O_NDELAY);
  if (fd == ERROR) {
  	perror("open");
  	exit(ERROR);
  }

}

/* -------------------------------------------------- */

void set_options(void)
{
  tcgetattr(fd, &options);
  
  options.c_cflag |= (CLOCAL | CREAD);
  options.c_cflag &= ~PARENB;
  options.c_cflag &= ~CSTOPB;
  options.c_cflag &= ~CSIZE; 
  options.c_cflag |= CS8;
  
  options.c_iflag |= (INPCK | ISTRIP);
  options.c_lflag &= ~(ICANON | ECHO | ISIG); 
  options.c_oflag &= ~OPOST;

  cfsetispeed(&options, B115200); 
  cfsetospeed(&options, B115200);

  tcsetattr(fd, TCSANOW, &options);
}

/* -------------------------------------------------- */

void init_modem(void)
{
  printf("Initializing modem (port %s)....\n", modemport);

  /* Hang up modem if it's already on */
  
  hangup();

  numbytes=write(fd, "ATZ\r", 4);
  check_for_error(fd, numbytes, "write");

  sleep(3);

}

/* -------------------------------------------------- */

void dial_number(void)
{

  char phonenum[20];   /* If local: phonenum = First3Digits + ScanMin   */
                       /* If long distance: phonenum =                  */
                       /* First3Digits + Last3Digits + ScanMin          */
  char phonenum1[20];  /* Same as above except this has "\r" as well    */
  char connectmsg[50]; /* the message to the log file			*/

  printf("Giving a %s second connection timeout", TIMEOUT);


  if ((strncasecmp(LocalOrLong, "L", 1)) == 0) {  /* Local call */

        while (1) {

		if (random == 1) ScanMin = (rand() % 8889) + 1111;

	  	strcat(phonenum, (char *)First3Digits);
       	        strcat(phonenum, (char *)ScanMin);
        	strcpy(phonenum1, (char *)phonenum);
        	strcat(phonenum1, "\r");

		if (random != 1) {
        		printf("Dialing %d-%d.\n", First3Digits, ScanMin);
        		numbytes = write(fd, phonenum1, strlen(phonenum1));
			check_for_error(fd, numbytes, "write");
		}

                else { /* if random == 1 */
                        printf("Dialing %d-%d.\n", First3Digits, ScanMin);
                        numbytes = write(fd, phonenum1, strlen(phonenum1));
			check_for_error(fd, numbytes, "write");
                }

        	sleep(TIMEOUT); /* How long to wait for timeout */

        	numbytes = read(fd, buf, 511);
		check_for_error(fd, numbytes, "read");

        	/* Compare the string with "CONNECT" */
                if((strncmp(buf, "CONNECT", 7)) == 0) {
		 	#ifdef WANTBEEP
                        fputc('\a', stderr);
                        #endif
                        fprintf(stderr, "*** CONNECT *** to %d-%d\n", First3Digits, ScanMin);

                        /* Log it */
                        sprintf(connectmsg, "*** CONNECT *** to %d-%d\n", First3Digits, ScanMin);
                        fputs(connectmsg, logfile);
        
                        bzero(connectmsg, 50); /* Clear the message */
                }
                
                bzero(buf, 512); /* Reset buffer */

		hangup();

		if (random != 1) {

			/* Increase ScanMin so it scans for the next number */
			ScanMin += 1;
            
               	        if (ScanMin > ScanMax) {
                		fputc('\a', stderr);
                        	fprintf(stderr, "ALL DONE SCANNING....THANKS FOR USING\n");
				exit(0);
                	}
		
		} 

		bzero(phonenum, 20);  /* Clear the phone number */
                bzero(phonenum1, 20); /* Ditto 		       */

	} /* End of while loop */
 } /* End of if */

  else { /* if LocalOrLong == "D" (Long Distance call) */ 
  
	while(1) {

		if (random == 1) ScanMin = (rand() % 8889) + 1111;

	  	strcat(phonenum, "1");
		strcat(phonenum, (char *)First3Digits); /* Area Code */
		strcat(phonenum, (char *)Last3Digits);  /* 1-XXX-555-XXXX */
		strcat(phonenum, (char *)ScanMin); /* 1-XXX-XXX-0000 */
        	strcpy(phonenum1, (char *)phonenum); /* Copy it to another */
        	strcat(phonenum1, "\r");       /* buf to append "\r" to it */

		if (random != 1) {
			printf("Dialing 1-%d-%d-%d.\n", First3Digits, Last3Digits, ScanMin);
		        numbytes = write(fd, phonenum1, strlen(phonenum1));
        		check_for_error(fd, numbytes, "write");
                }

                else { /* if random == 1 */
                        printf("Dialing 1-%d-%d-%d.\n", First3Digits, Last3Digits, ScanMin);
                        numbytes = write(fd, phonenum1, strlen(phonenum1));
                        check_for_error(fd, numbytes, "write");
                }
                
	        sleep(TIMEOUT); /* How long to wait for timeout */

                numbytes = read(fd, buf, 511);
                check_for_error(fd, numbytes, "read");
        
                /* Compare the string with "CONNECT" */
                if((strncmp(buf, "CONNECT", 7)) == 0) {
                        fputc('\a', stderr);
                        fprintf(stderr, "*** CONNECT *** to 1-%d-%d-%d\n", First3Digits, Last3Digits, ScanMin);

			/* Log it */
                        sprintf(connectmsg, "*** CONNECT *** to 1-%d-%d-%d\n", First3Digits, Last3Digits, ScanMin);
			fputs(connectmsg, logfile);

                        bzero(connectmsg, 50); /* Clear the message */
                }

                bzero(buf, 512); /* Reset buffer */

		hangup();

                if (random != 1) {

	                /* Increase ScanMin so it scans for the next number */
        	        ScanMin += 1;
                        
             	        if (ScanMin > ScanMax) {
                        	fputc('\a', stderr);
                        	fprintf(stderr, "ALL DONE SCANNING....THANKS FOR USING\n");
                        	break;
                	}

		}

               	bzero(phonenum, 20);  /* Clear the phone number */
               	bzero(phonenum1, 20); /* Ditto                  */


	} /* End of while loop */
  } /* End of if/else loop */

  fclose(logfile);
} /* End of dial_num */

void hangup(void)
{
    /* After testing put this in the init_modem() section */
    /* for optimize it.					  */

    int fd1; /* fd for modem (hang up) */

    fd1=open(hangupport, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd1 == ERROR) {
    	perror("open");
	close(fd1);
	close(fd);
	exit(ERROR);
    }

    numbytes=write(fd1, "+++\r", 4);
    check_for_error(fd1, numbytes, "write");

    sleep(1);

    numbytes=write(fd1, "ATH\r", 4);
    check_for_error(fd1, numbytes, "write");

    sleep(3);	  
    
    /* Should/will check for "OK */
    close(fd1);

}

void sighandler(int signum)
{
  char message[50];

  fprintf(stderr, "Receive signal to quit....closing up modem, logging last number dialed, and exitting\n");
  if (random != 1) fprintf(stderr, "Last number dialed was: ");
	
  if((strncasecmp(LocalOrLong, "L", 1)) == 0) {
	if (random != 1) {
		sprintf(message, "%d-%d\n", First3Digits, Last3Digits);
       	        fprintf(stderr, message);
        	fprintf(logfile, message);
	/*     	fprintf(resume, "%d%d\n", First3Digits, Last3Digits); */
        }
  }
  else { /* if LocalOrLong == "D" */
	if (random != 1) {
		sprintf(message, "1-%d-%d-%d\n", First3Digits, Last3Digits, ScanMin);
	        fprintf(stderr, message);
	        fprintf(logfile, message);
	/*      fprintf(resume, "1%d%d%d\n", First3Digits, Last3Digits, ScanMin); */
	}
  }

  /* hangup(); */
  close(fd);
  /* fclose(resume); */
  fclose(logfile);
  exit(ERROR);
}

/* void resume(void) 
   {

   }
*/
